/* 
 * Gemix Studio (C) 2016 Skygem Software, All right reserved
 * Example: Block system
 */

// use this option to inform the system to use the modern graphics engine with hardware acceleration (OpenGL, etc...)
compiler_options _gmxsystem_graphics = gmxgraphics_modern;
program Gemix_blocks_process;
 
private
  render_transform_block t_block;
 
begin
	mode_set(640, 480);
	
  // Loads graphics' file
  fpg_load("assets/test_effects32.fpg");

  // Render background
  ground_put(0, 999);
  
  // Set render block common options
  t_block.used     = 1;
  t_block.width    = 20;
  t_block.height   = 20;
  
  // Render gem block's at different position and anchor
  // NOTE: when use a block (used = 1), LOCAL X and Y (position) are ignored, use block target x/y instead
  t_block.target.x = 320;
  t_block.target.y = 120;
  t_block.source.x = 15;
  t_block.source.y = 10;
  proc_gem(transform_anchor_cpoint0, t_block, true);
 
  t_block.target.x = 0;
  t_block.target.y = 0;
  t_block.source.x = 0;
  t_block.source.y = 0;
  proc_gem(transform_anchor_topleft, t_block, false);    
  t_block.target.x = 320;
  t_block.target.y = 0;
  t_block.source.x = 15;
  t_block.source.y = 0;
  proc_gem(transform_anchor_topcenter, t_block, false);
  t_block.target.x = 639;
  t_block.target.y = 0;
  t_block.source.x = 30;
  t_block.source.y = 0;  
  proc_gem(transform_anchor_topright, t_block, false);

  t_block.target.x = 0;
  t_block.target.y = 240;
  t_block.source.x = 0;
  t_block.source.y = 10;    
  proc_gem(transform_anchor_left, t_block, false);  
  t_block.target.x = 320;
  t_block.target.y = 240;
  t_block.source.x = 15;
  t_block.source.y = 10;    
  proc_gem(transform_anchor_center, t_block, false);  
  t_block.target.x = 639;
  t_block.target.y = 240;
  t_block.source.x = 30;
  t_block.source.y = 10;    
  proc_gem(transform_anchor_right, t_block, false);

  t_block.target.x = 0;
  t_block.target.y = 479;
  t_block.source.x = 0;
  t_block.source.y = 20;    
  proc_gem(transform_anchor_bottomleft, t_block, false);  
  t_block.target.x = 320;
  t_block.target.y = 479;
  t_block.source.x = 15;
  t_block.source.y = 20;    
  proc_gem(transform_anchor_bottomcenter, t_block, false);  
  t_block.target.x = 639;
  t_block.target.y = 479;
  t_block.source.x = 30;
  t_block.source.y = 20;      
  proc_gem(transform_anchor_bottomright, t_block, false);

	repeat
		frame;
	until(keydown(_esc));
  let_me_alone();
end

process proc_gem(anchor, block, animation)
begin
	graph = 1;
  if(animation)
    scale   = vec_new(300.0F, 300.0F);
    fx.mode = fx_blend_rb; 
  end
  
	loop
    if(animation)
      rotation.z -= 11250;
    end
  
		frame;
	end
end
